
#include "common.h"

#include <winsock.h>
#include <mmsystem.h>
#include <ddraw.h>
#include <dsound.h>
#include <dinput.h>
#include <dir.h>
#include <commctrl.h>
#include <shlobj.h>     // For directories configuration dialog.

#include "input.h"
#include "joystick.h"
#include "keyboard.h"
#include "cheat.h"


static int eoptions=0;
#define EO_BGRUN         1

#define EO_CPALETTE      4
#define EO_NOSPRLIM      8
#define EO_BSAV         16
#define EO_FSAFTERLOAD  32
#define EO_FOAFTERSTART 64

void ResetVideo(void);
void ShowCursorAbs(int w);
void HideFWindow(int h);
int SetMainWindowStuff(void);
int GetClientAbsRect(LPRECT lpRect);
void UpdateFCEUWindow(void);


HWND hAppWnd=0;
HINSTANCE fceu_hInstance;

HRESULT  ddrval;
int gametype;
void FCEUD_SendMessage(int msg)
{
 switch(msg)
 {
  case DSM_RESETSPECIAL: gametype=0;break;
  case DSM_SPECIALSYSTEM_VSUNISYSTEM:
  case DSM_SPECIALSYSTEM_NSF:
  case DSM_SPECIALSYSTEM_FDS: gametype=msg;break;
 }
}


// cheats, misc, nonvol, states, snaps, base
static char *DOvers[6]={0,0,0,0,0,0};
static char *defaultds[5]={"cheats","gameinfo","sav","fcs","snaps"};

static char TempArray[2048];
static char BaseDirectory[2048];

void SetDirs(void)
{
 int x;
 static int jlist[5]=
  {FCEUIOD_CHEATS,FCEUIOD_MISC,FCEUIOD_NV,FCEUIOD_STATE,FCEUIOD_SNAPS};

 for(x=0;x<5;x++)
  FCEUI_SetDirOverride(jlist[x], DOvers[x]);  
 if(DOvers[5])
  FCEUI_SetBaseDirectory(DOvers[5]);
 else
  FCEUI_SetBaseDirectory(BaseDirectory);
 FCEUI_SaveExtraDataUnderBase(eoptions&EO_BSAV);
}
/* Remove empty, unused directories. */
void RemoveDirs(void)
{
 int x;

 for(x=0;x<5;x++)
  if(!DOvers[x])
  {
   sprintf(TempArray,"%s\\%s",DOvers[5]?DOvers[5]:BaseDirectory,defaultds[x]);
   RemoveDirectory(TempArray);
  }
}

void CreateDirs(void)
{
 int x;

 for(x=0;x<5;x++)
  if(!DOvers[x])
  {
   sprintf(TempArray,"%s\\%s",DOvers[5]?DOvers[5]:BaseDirectory,defaultds[x]);
   CreateDirectory(TempArray,0);
  }
}

static char *gfsdir=0;
void GetBaseDirectory(void)
{
 int x;
 BaseDirectory[0]=0;
 GetModuleFileName(0,(LPTSTR)BaseDirectory,2047);

 for(x=strlen(BaseDirectory);x>=0;x--)
 {
  if(BaseDirectory[x]=='\\' || BaseDirectory[x]=='/')
   {BaseDirectory[x]=0;break;}
 }
}

void BlockingCheck(void)
{
  MSG msg;

  while( PeekMessage( &msg, 0, 0, 0, PM_NOREMOVE ) ) {
     if( GetMessage( &msg, 0,  0, 0)>0 )
     {
     TranslateMessage(&msg);
     DispatchMessage(&msg);          
     }
   } 
}


int NoWaiting=0;
static int fullscreen=0;
static int soundflush=0;
static int genie=0;
static int palyo=0;
static int windowedfailed;
static int winsizemul=1;
static int winwidth,winheight;
static volatile int nofocus=0;
static int soundrate=44100;
static int soundbuftime=46;
static int soundbufsize;        
static int soundoptions=0;
static int soundvolume=100;

static unsigned int srendline=8;
static unsigned int erendline=239;
static unsigned int totallines;

static void UpdateRendBounds(void)
{
 totallines=erendline-srendline+1;
 FCEUI_SetFirstRenderedLine(srendline);
 FCEUI_SetLastRenderedLine(erendline);
}

static uint8 cpalette[192];
static int vmod=1;
static int soundo=1;
static int ntsccol=0,ntsctint,ntschue;

void FCEUD_PrintError(char *s)
{
 if(fullscreen) ShowCursorAbs(1);
 MessageBox(0,s,"FCE Ultra Error",MB_ICONERROR|MB_OK|MB_SETFOREGROUND|MB_TOPMOST);
 if(fullscreen)ShowCursorAbs(0);
}

void ShowAboutBox(void)
{
 sprintf(TempArray,"FCE Ultra "VERSION_STRING"\n\nhttp://fceultra.sourceforge.net\n\n"__TIME__"\n"__DATE__"\n""gcc "__VERSION__);
 MessageBox(hAppWnd,TempArray,"About FCE Ultra",MB_OK);
}

static int exiting=0;
int gameloaded=0;

void DoFCEUExit(void)
{
 exiting=1;
 if(gameloaded)
 {
  FCEUI_CloseGame();
  gameloaded=0;
 }
}

static int changerecursive=0;
//#include "joystick.c"
//#include "keyboard.c"

#include "netplay.c"
//#include "cheat.c"
#include "sound.c"
#include "video.c"
#include "window.c"
#include "config.c"


int DriverInitialize(void)
{
  int t;
  t=1;
  if(!InitializeDDraw()) return 0; 
  soundo=InitSound();

  if(!SetVideoMode())
  {
   if(!fullscreen)
   {
    fullscreen=1;
    if(!SetVideoMode())
     return 0;
   }
   else
    return 0;
  }
  CreateInputStuff();
  return 1;
}

static void DriverKill(void)
{ 
 sprintf(TempArray,"%s/fceu.cfg",BaseDirectory);
 SaveConfig(TempArray);
 DestroyInput();
 ResetVideo();
 if(soundo) TrashSound();
 CloseWave();
 ByebyeWindow();
}


int main(int argc,char *argv[])
{
  char *t;

  if(!FCEUI_Initialize())
   goto doexito;

  fceu_hInstance=GetModuleHandle(0);

  GetBaseDirectory();

  sprintf(TempArray,"%s\\fceu.cfg",BaseDirectory);
  LoadConfig(TempArray);

  CreateDirs();
  SetDirs();

  DoVideoConfigFix();
  DoMiscConfigFix();

  if(eoptions&EO_CPALETTE)
   FCEUI_SetPaletteArray(cpalette);

  t=0;
  if(argc>1)
   t=argv[1];
  if(!t) fullscreen=0;

  CreateMainWindow();

  if(!InitDInput())
   goto doexito;

  DriverInitialize();
  UpdateMenu();

  if(t)
  {
   if(!FCEUI_LoadGame(t))
    goto doexito;
   gameloaded=1;
  }
  else if(eoptions&EO_FOAFTERSTART)
   LoadNewGamey(hAppWnd);

  doloopy:
  UpdateFCEUWindow();
  if(gameloaded)
  {
   FCEUI_Emulate();
   RedrawWindow(hAppWnd,0,0,RDW_ERASE|RDW_INVALIDATE);
   StopSound();
  }
  Sleep(50);
  if(!exiting)
   goto doloopy;

  doexito:
  DriverKill();
  return(0);
}
