TEMPLATE	= app
CONFIG		= qt warn_on release
DESTDIR		= .
HEADERS		= qpe_fceu.h banksw.h \
boards/mapinc.h \
cart.h \
cheat.h \
codes.h \
crc32.h \
drawing.h \
driver.h \
endian.h \
fce.h \
fceline.h \
fcelineasm.h \
fds.h \
file.h \
general.h \
ggrom.h \
ines.h \
input.h \
m6502.h \
mappers/fmopl.h \
mappers/mapinc.h \
mappers/mapshare.h \
mappers/mmc3irq.h \
mbshare/mapinc.h \
mbshare/mmc3irq.h \
memory.h \
netplay.h \
nsf.h \
nsfbgnew.h \
palette.h \
palettes/nsfnew.h \
palettes/rp2c04001.h \
palettes/vscv.h \
palettes/vseb.h \
palettes/vsgoonies.h \
palettes/vsgrad.h \
palettes/vsmar.h \
palettes/vsplatoon.h \
palettes/vsslalom.h \
palettes/vssmb.h \
powerpad.h \
sound.h \
svga.h \
state.h \
tables.h \
types.h \
unif.h \
version.h \
video.h \
zapper.h \
drivers/common/unixdsp.h \
fileBrowser.h

SOURCES		= qpe_fceu.cpp boards/malee.c \
boards/novel.c \ 
boards/simple.c \ 
boards/super24.c \ 
boards/supervision.c \
cart.c \
cheat.c \
crc32.c \
endian.c \
fce.c \
fds.c \
file.c \
general.c \
ines.c \
input.c \
m6502.c \
mappers/105.c \
mappers/112.c \
mappers/113.c \
mappers/117.c \
mappers/15.c \
mappers/151.c \
mappers/16.c \
mappers/17.c \
mappers/18.c \
mappers/180.c \
mappers/182.c \
mappers/184.c \
mappers/19.c \
mappers/21.c \
mappers/22.c \
mappers/225.c \
mappers/226.c \
mappers/227.c \
mappers/228.c \
mappers/229.c \
mappers/23.c \
mappers/232.c \
mappers/234.c \
mappers/240.c \
mappers/242.c \
mappers/246.c \
mappers/248.c \
mappers/24and26.c \
mappers/25.c \
mappers/32.c \
mappers/33.c \
mappers/40.c \
mappers/41.c \
mappers/42.c \
mappers/43.c \
mappers/44.c \
mappers/45.c \
mappers/46.c \
mappers/47.c \
mappers/49.c \
mappers/6.c \
mappers/64.c \
mappers/65.c \
mappers/67.c \
mappers/68.c \
mappers/69.c \
mappers/71.c \
mappers/72.c \
mappers/73.c \
mappers/75.c \
mappers/76.c \
mappers/77.c \
mappers/79.c \
mappers/8.c \
mappers/80.c \
mappers/82.c \
mappers/83.c \
mappers/85.c \
mappers/86.c \
mappers/88.c \
mappers/89.c \
mappers/90.c \
mappers/92.c \
mappers/95.c \
mappers/97.c \
mappers/99.c \
mappers/fmopl.c \
mappers/mmc2and4.c \
mappers/simple.c \
mappers/vrc7snd.c \
mbshare/mmc1.c \
mbshare/mmc3.c \
mbshare/mmc5.c \
memory.c \
netplay.c \
nsf.c \
powerpad.c \
sound.c \
state.c \
svga.c \
unif.c \
video.c \
zapper.c \
drivers/common/unixdsp.c \
fileBrowser.cpp

INTERFACES	= 

DEFINES = PSS_STYLE=1 LSB_FIRST UNIX LINUX FPS FRAMESKIP
INCLUDEPATH += $(QPEDIR)/include/qpe
DEPENDPATH	+= $(QPEDIR)/include/qpe
LIBS            += -L$(QPEDIR)/sharp/lib -lqpe

TARGET		= fceu

TMAKE_CFLAGS_RELEASE = -O3 -mtune=strongarm
