#include "mapinc.h"

static void DoIt(void)
{
  ROM_BANK16(0x8000,(mapbyte1[1]&3) | ((mapbyte1[0]&0x18)>>1));
  ROM_BANK16(0xc000,3|(((mapbyte1[0])&0x18)>>1));
}

DECLFW(Mapper232_write)
{
	if(A<=0x9FFF)
	 mapbyte1[0]=V;
	else
	 mapbyte1[1]=V;
	DoIt();
}

static void QuattroReset(void)
{
 mapbyte1[0]=0x18;
 DoIt();
}

void Mapper232_init(void)
{
 SetWriteHandler(0x6000,0xffff,Mapper232_write);
 MapperReset=QuattroReset;
 QuattroReset();
}

