#include "mapinc.h"

static void Fixerit(void)
{
 switch(mapbyte2[0]&3)
 {
  case 0:vnapage[0]=vnapage[2]=VROM+(((mapbyte1[0]|128)&CHRmask1[0])<<10);
	 vnapage[1]=vnapage[3]=VROM+(((mapbyte1[1]|128)&CHRmask1[0])<<10);
	 break;
  case 1:vnapage[0]=vnapage[1]=VROM+(((mapbyte1[0]|128)&CHRmask1[0])<<10);
         vnapage[2]=vnapage[3]=VROM+(((mapbyte1[1]|128)&CHRmask1[0])<<10);
         break;
  case 2:vnapage[0]=vnapage[1]=vnapage[2]=vnapage[3]=VROM+(((mapbyte1[0]|128)&CHRmask1[0])<<10);
	 break;
  case 3:vnapage[0]=vnapage[1]=vnapage[2]=vnapage[3]=VROM+(((mapbyte1[1]|128)&CHRmask1[0])<<10);
	 break;
 }
}

DECLFW(Mapper68_write)
{
 A&=0xF000;

 if(A>=0x8000 && A<=0xB000)
 {
  VROM_BANK2((A-0x8000)>>1,V);
 }
 else switch(A)
 {
  case 0xc000:mapbyte1[0]=V;
              if(VROM_size && mapbyte2[0]&0x10)
	       Fixerit();
              break;

  case 0xd000:mapbyte1[1]=V;
	      if(VROM_size && mapbyte2[0]&0x10)
	       Fixerit();
              break;

  case 0xe000: mapbyte2[0]=V;
               if(!(V&0x10))
               {
                switch(V&3)
                {
                 case 0:MIRROR_SET2(1);break;
                 case 1:MIRROR_SET2(0);break;
                 case 2:onemir(0);break;
                 case 3:onemir(1);break;
                }
               }
               else if(VROM_size)
	       {
	        Fixerit();
	        PPUNTARAM=0;
	       }
               break;
  case 0xf000: ROM_BANK16(0x8000,V);break;
 }
}

static void Mapper68_StateRestore(int version)
{
              if(!(mapbyte2[0]&0x10))
              {
               switch(mapbyte2[0]&3)
               {
                case 0:MIRROR_SET(0);break;
                case 1:MIRROR_SET(1);break;
                case 2:onemir(0);break;
                case 3:onemir(1);break;
               }
              }
              else if(VROM_size)
              {
		Fixerit();
                PPUNTARAM=0;
              }
}

void Mapper68_init(void)
{
 SetWriteHandler(0x8000,0xffff,Mapper68_write);
 MapStateRestore=Mapper68_StateRestore;
}
